#pragma once

#include "../DayEventWidgets/DayEventWidgets.h"

class DayEventWidgets;

/**
* Trida, udrzujici hodnoty jedne akce , jako napr. je snidane nebo vecere.
*/
class DayEventValues : public QWidget
{
	Q_OBJECT

public:
	/* Vytvori nove hodnoty akce s casem default_time. */
	DayEventValues(int default_time);
	virtual ~DayEventValues();

	/* Vrati jestli je udalost pouzita. */
	bool getEventIsChecked();

	/* Nastavi jestli je udalost pouzita. */
	void setEventIsChecked(bool eventIsChecked);

	/* Vrati hodnotu udalosti. */
	double getEventValue();

	/* Nastavi hodnotu udalosti. */
	void setEventValue(double eventValue);

	/*  Vrati hodiny, kdy udalost probiha. */
	int getEventTimeHours();

	/* Nastavi hodiny, kdy udalost probiha */
	void setEventTimeHours(int eventTimeHours);

	/* Vrati minuty, kdy udalost probiha. */
	int getEventTimeMinutes();

	/* Nastavi minuty, kdy udalost probiha. */
	void setEventTimeMinutes(int eventTimeMinutes);

	/* Vrati hodnotu jitteru. */
	double getEventJitter();

	/* Nastavi hodnotu jitteru. */
	void setEventJitter(double eventJitter);

	/* Ulozi globalni hodnoty daneho dne. */
	void saveEvent(DayEventWidgets *eventWidgets);

private:

	/* Bool, pro urceni, jestli se bude s danou udalosti pocitat.  */
	bool eventIsChecked;

	/* Hodnota z dane udalost (napr. mnozstvi cukru). */
	double eventValue;

	/* Hodiny, kdy udalost probiha. */
	int eventTimeHours;

	/* Minuty, kdy udalost probiha. */
	int eventTimeMinutes;

	/* Hodnota jitteru. */
	double eventJitter;
};