#include "ThreadObject.h"

ThreadObject::ThreadObject(int index, scgms::SPersistent_Filter_Chain_Configuration configuration, scgms::TMetric_Descriptor *metricDescriptor)
{
	this->index = index;
	this->configuration = configuration;
	this->metricDescriptor = metricDescriptor;
}

ThreadObject::ThreadObject(int index, scgms::SPersistent_Filter_Chain_Configuration configuration, std::wstring configFileName, scgms::TMetric_Descriptor *metricDescriptor)
{
	this->index = index;
	this->configuration = configuration;
	this->configFileName = configFileName;
	this->metricDescriptor = metricDescriptor;
}

ThreadObject::~ThreadObject()
{

}

void ThreadObject::addToQueue(std::queue<ThreadObject*> queue)
{
	// Prida se prvek do fronty.
	queue.push(this);
}

ThreadObject * ThreadObject::removeFromQueue(std::queue<ThreadObject*> queue)
{
	// Pokud je fronta prazdna, uspi se.
	while (queue.empty()) {
		std::this_thread::sleep_for(std::chrono::milliseconds(500));
	}

	// Vrati prvni prvek fronty.
	ThreadObject* returnObject = queue.front();
	// Odstrani prvek z fronty.
	queue.pop();

	// Vrati se vybrany prvek.
	return returnObject;
}
