#include "FirstDefWindow.h"

#include <QtWidgets/QApplication>
#include <QtWidgets/QMessageBox>

#include <iostream>

FirstDefWindow::FirstDefWindow() : QMainWindow(nullptr)
{
	// Nastaveni titulku.
	setWindowTitle("Scenario_definition");

	// Nastaveni velikosti okna.
	this->resize(300, 100);

	// Inicializace promennych.
	mw = NULL;
	diabetValue = true;
	ageValue = 10;
	dailyValue = true;
	numOfWeeksValue = 1;
	//

	// Inicializace widgetu.
	QWidget* centralWidget = new QWidget();
	QGridLayout* centralLayout = new QGridLayout();

	ageLabel = new QLabel("Age:");
	diabetLabel = new QLabel("Diabete type:");
	numOfWeeksLabel = new QLabel("Number of weeks:");

	age = new QSpinBox();
	diabet = new QComboBox();
	daily = new QCheckBox("Daily generated");
	numOfWeeks = new QSpinBox();

	age->setValue(ageValue);
	daily->setChecked(dailyValue);
	numOfWeeks->setValue(numOfWeeksValue);

	diabet->addItem("DM I. type");
	diabet->addItem("DM II. type");
	diabet->setCurrentIndex(0);
	//

	int x = 0;

	// Umisteni widgetu.
	centralLayout->addWidget(ageLabel, ++x, 0, 1, 1);
	centralLayout->addWidget(age, x, 1, 1, 1);
	centralLayout->addWidget(diabetLabel, ++x, 0, 1, 1);
	centralLayout->addWidget(diabet, x, 1, 1, 1);
	centralLayout->addWidget(numOfWeeksLabel, ++x, 0, 1, 1);
	centralLayout->addWidget(numOfWeeks, x, 1, 1, 1);
	centralLayout->addWidget(daily, ++x, 0, 1, 1);

	continueButton = new QPushButton("Continue");
	centralLayout->addWidget(continueButton, ++x, 1, 1, 1);

	centralWidget->setLayout(centralLayout);

	setCentralWidget(centralWidget);
	//

	// Ziskani hodnnot veku ze spinboxu.
	connect(age, QOverload<int>::of(&QSpinBox::valueChanged),
		[=](int index) {	ageValue = age->value();
		});

	// Ziskani hodnoty tyou diabetu z comboboxu.
	connect(diabet, QOverload<int>::of(&QComboBox::currentIndexChanged),
		[=](int index) { 
			if (diabet->currentIndex() == 1) {
				diabetValue = true;
			}
			else {
				diabetValue = false;
			}});
	

	// Ziskani hodnoty denniho generovani z checkboxu.
	connect(daily, &QCheckBox::stateChanged,
		[=](const bool) {	dailyValue = daily->checkState();
		});

	// Ziskani hodnoty poctu tydnu.
	connect(numOfWeeks, QOverload<int>::of(&QSpinBox::valueChanged),
		[=](int index) {	
			numOfWeeksValue = numOfWeeks->value();
		});

	// Stlaceni tlacitka pro pokracovani.
	connect(continueButton, SIGNAL(clicked()), this, SLOT(OnContinueButtonClick()));
}


FirstDefWindow::~FirstDefWindow()
{

}

void FirstDefWindow::OnContinueButtonClick()
{
	if (numOfWeeksValue > 0) {
		
		// Zablikuje se tlacitko Continue.
		continueButton->setDisabled(true);

		// Vytvori se objekt MainDefWindow pro druhe okno.
		mw = new MainDefWindow();

		// Predaji se hodnoty, ziskane z tohoto okna.
		mw->setAgeValue(ageValue);
		mw->setDiabetValue(diabetValue);
		if (dailyValue == true) {
			mw->setNumOfDays(1);
		} else {
			mw->setNumOfDays(7);
		}
		mw->setNumOfWeeks(numOfWeeksValue);

		// Inicializuje se druhe okno.
		mw->initWindow();

		// Zobrazi se druhe okno.
		mw->show();

		// toto okno se uzavre.
		this->close();
	} else {
		// Byl zadan ulovy pocet tydnu, nic se nedeje.
		return;
	}
}
