
#pragma once

#include <QtWidgets/QMainWindow>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QLabel>
#include <QtWidgets/QLineEdit>
#include <QtWidgets/QBoxLayout>
#include <QtWidgets/QGroupBox>
#include <QtWidgets/QDateEdit>
#include <QtWidgets/QStackedWidget>
#include <QtWidgets/QFormLayout>
#include <QtWidgets/QCheckBox>
#include <QtWidgets/QDoubleSpinBox>
#include <QtWidgets/QComboBox>
#include <QtWidgets/QToolBox>
#include <QtWidgets/QProgressBar>
#include <QtWidgets/QProgressDialog>
#include <QMessageBox>

#include <rtl/scgmsLib.h>
#include <rtl/FilterLib.h>
#include <rtl/referencedImpl.h>
#include <dep/scgms/utils/QtUtils.h>
#include <qdir.h>
#include <dep/scgms/rtl/SolverLib.h>
#include <dep/scgms/utils/string_utils.h>
#include <dep/scgms/rtl/rattime.h>
#include <rtl/scgmsLib.h>
#include <rtl/UILib.h>


#include <memory>
#include <condition_variable>
#include <vector>
#include <random>
#include <thread>
#include <iostream>
#include <fstream>
#include <queue>

/* Cas snidane v hodinach. */
#define BREAKFAST_TIME_HOURS 8

/* Cas dopoledni snidane v hodinach. */
#define SNACK_MORNING_TIME_HOURS 10

/* Cas obeda v hodinach. */
#define LUNCH_TIME_HOURS 12

/* Cas odpoledni svaciny v hodinach. */
#define SNACK_AFTERNOON_HOURS 16

/* Cas vecere v hodinach. */
#define DINNER_TIME_HOURS 18

/* Cas pohybu v hodinach. */
#define MOVEMENT_TIME_HOURS 9

/* Maximalni hodnota pro potravu. */
#define VALUE_MAX 1000

/* Cas uspani vlakna v milisec. */
#define THREAD_SLEEP 500

/* Krok pro zmenu fyzicke aktivity. */
#define SINGLE_STEP 0.05

/* Maimalni hodnota fyzicke aktivity. */
#define MAX_STEP 0.6

/* Maximalni pocet nahranych souboru konfiguraci. */
#define MAX_X_FILES 10000

/* Maximalni hodnota progress baru. */
#define MAX_BAR 100

/* Znacka pro progressbar, ze je vypocet jedne konfigurace hotov. */
#define COUNT_PART_DONE 101

/* ID filtru pro metriky.*/
constexpr GUID Error_Filter = { 0x690fbc95, 0x84ca, 0x4627, { 0xb4, 0x7c, 0x99, 0x55, 0xea, 0x81, 0x7a, 0x4f } };

/* Nazev slozky pro nakopirovany soubor se scenarem. */
#define OUTPUT_DIR L"output_configs"
