/* Examples and Documentation for
 * SmartCGMS - continuous glucose monitoring and controlling framework
 * https://diabetes.zcu.cz/
 *
 * Copyright (c) since 2018 University of West Bohemia.
 *
 * Contact:
 * diabetes@mail.kiv.zcu.cz
 * Medical Informatics, Department of Computer Science and Engineering
 * Faculty of Applied Sciences, University of West Bohemia
 * Univerzitni 8, 301 00 Pilsen
 * Czech Republic
 * 
 * 
 * Purpose of this software:
 * This software is intended to demonstrate work of the diabetes.zcu.cz research
 * group to other scientists, to complement our published papers. It is strictly
 * prohibited to use this software for diagnosis or treatment of any medical condition,
 * without obtaining all required approvals from respective regulatory bodies.
 *
 * Especially, a diabetic patient is warned that unauthorized use of this software
 * may result into severe injure, including death.
 *
 *
 * Licensing terms:
 * Unless required by applicable law or agreed to in writing, software
 * distributed under these license terms is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

#pragma once

#include <rtl/guid.h>

/* GUID Frechetovy vzdalenosti. */
namespace frechet_distance {

	constexpr GUID id = { 0x35d2a414, 0x9e1f, 0x4d96, { 0xaa, 0x96, 0xcc, 0x13, 0xf6, 0x74, 0x3b, 0x86 } };	// {35D2A414-9E1F-4D96-AA96-CC13F6743B86}
}

/* GUID Hausdorffovy vzdalenosti. */
namespace hausdorff_distance {

	constexpr GUID id = { 0x23c0ccc3, 0xa48d, 0x4b88, { 0x94, 0x8d, 0x5b, 0x2e, 0x32, 0x1c, 0xd2, 0xb5 } };	// {23C0CCC3-A48D-4B88-948D-5B2E321CD2B5}
}

/* GUID Hausdorffovy vzdalenosti modifikoavne Manhattanskou metrikou. */
namespace hausdorff_distance_man {

	constexpr GUID id = { 0x8757530a, 0x58f0, 0x46f2, { 0xa0, 0xb7, 0x6c, 0x26, 0x73, 0xe6, 0x5e, 0xe2 } };	// {8757530A-58F0-46F2-A0B7-6C2673E65EE2}
}

/* GUID Hausdorffovy vzdalenosti modifikovane Minkowskiho normou. */
namespace hausdorff_distance_min {

	constexpr GUID id = { 0xb8c3396, 0xd15c, 0x4eb8, { 0x8b, 0x18, 0x9c, 0x23, 0xf, 0x41, 0xdd, 0x85 } };	// {0B8C3396-D15C-4EB8-8B18-9C230F41DD85}
}

